diff --git a/web/pgadmin/browser/tests/test_logout.py b/web/pgadmin/browser/tests/test_logout.py
index 5697de6..403e35d 100644
--- a/web/pgadmin/browser/tests/test_logout.py
+++ b/web/pgadmin/browser/tests/test_logout.py
@@ -32,7 +32,7 @@ class LogoutTest(BaseTestGenerator):
         """This function checks the logout functionality."""
 
         response = self.tester.get('/logout')
-        self.assertIn(self.respdata, response.data.decode('utf8'))
+        self.assertTrue(self.respdata in response.data.decode('utf8'))
 
     @classmethod
     def tearDownClass(cls):
diff --git a/web/pgadmin/browser/tests/test_reset_password.py b/web/pgadmin/browser/tests/test_reset_password.py
index 0dcf0bd..17da1c4 100644
--- a/web/pgadmin/browser/tests/test_reset_password.py
+++ b/web/pgadmin/browser/tests/test_reset_password.py
@@ -6,12 +6,12 @@
 # #This software is released under the PostgreSQL Licence
 #
 # ##########################################################################
-
 import uuid
 
 from pgadmin.utils.route import BaseTestGenerator
 from regression.test_setup import config_data
-from test_utils import login_tester_account, logout_tester_account
+from regression.test_utils import login_tester_account
+from regression.test_utils import logout_tester_account
 
 
 class ResetPasswordTestCase(BaseTestGenerator):
@@ -45,12 +45,12 @@ class ResetPasswordTestCase(BaseTestGenerator):
         """This function checks reset password functionality."""
 
         response = self.tester.get('/reset')
-        self.assertIn('Recover pgAdmin 4 Password', response.data.decode(
+        self.assertTrue('Recover pgAdmin 4 Password' in response.data.decode(
             'utf-8'))
         response = self.tester.post(
             '/reset', data=dict(email=self.email),
             follow_redirects=True)
-        self.assertIn(self.respdata, response.data.decode('utf-8'))
+        self.assertTrue(self.respdata in response.data.decode('utf-8'))
 
     @classmethod
     def tearDownClass(cls):
diff --git a/web/pgadmin/browser/tests/utils.py b/web/pgadmin/browser/tests/utils.py
index 18548ce..3be84d7 100644
--- a/web/pgadmin/browser/tests/utils.py
+++ b/web/pgadmin/browser/tests/utils.py
@@ -10,7 +10,7 @@
 
 def change_password(self):
     response = self.tester.get('/change', follow_redirects=True)
-    self.assertIn('pgAdmin 4 Password Change', response.data.decode(
+    self.assertTrue('pgAdmin 4 Password Change' in response.data.decode(
         'utf-8'))
 
     response = self.tester.post('/change', data=dict(
@@ -18,4 +18,4 @@ def change_password(self):
         new_password=self.new_password,
         new_password_confirm=self.new_password_confirm),
                                 follow_redirects=True)
-    self.assertIn(self.respdata, response.data.decode('utf-8'))
\ No newline at end of file
+    self.assertTrue(self.respdata in response.data.decode('utf-8'))
diff --git a/web/pgadmin/utils/route.py b/web/pgadmin/utils/route.py
index 74269de..3abe0b5 100644
--- a/web/pgadmin/utils/route.py
+++ b/web/pgadmin/utils/route.py
@@ -6,10 +6,12 @@
 # This software is released under the PostgreSQL Licence
 #
 ##############################################################
-
+import traceback
 import sys
-import unittest
-
+if sys.version_info < (2, 7):
+    import unittest2 as unittest
+else:
+    import unittest
 from abc import ABCMeta, abstractmethod
 from importlib import import_module
 from werkzeug.utils import find_modules
@@ -70,7 +72,7 @@ class TestsGeneratorRegistry(ABCMeta):
                     if "tests." in str(module_name):
                         cls.import_app_modules(module_name)
                 except ImportError:
-                    pass
+                    traceback.print_exc(file=sys.stderr)
         else:
             for module_name in find_modules(pkg, False, True):
                 try:
@@ -79,7 +81,8 @@ class TestsGeneratorRegistry(ABCMeta):
                     if "pgadmin.browser.tests" not in module_name:
                         cls.import_app_modules(module_name)
                 except ImportError:
-                    pass
+                    traceback.print_exc(file=sys.stderr)
+
 
 import six
 
diff --git a/web/regression/__init__.py b/web/regression/__init__.py
index 6b7cb2f..36ae3f8 100644
--- a/web/regression/__init__.py
+++ b/web/regression/__init__.py
@@ -9,6 +9,11 @@
 import pgadmin.browser.server_groups.servers.roles.tests.utils as roles_utils
 import pgadmin.browser.server_groups.servers.tablespaces.tests.utils as \
     tablespace_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import\
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.functions.tests\
+    import utils as trigger_funcs_utils
+
 
 global node_info_dict
 node_info_dict = {
@@ -16,22 +21,14 @@ node_info_dict = {
     "did": [],  # database
     "lrid": [],  # role
     "tsid": [],  # tablespace
-    "scid": [],  # schema
-    "tfnid": [],  # trigger functions
-    "coid": [],  # collation
-    "cid": [],  # casts
-    "etid": [],  # event_trigger
-    "eid": [],  # extension
-    "fid": [],  # FDW
-    "fsid": [],  # FRS
-    "umid": [],  # user_mapping
-    "seid": []  # sequence
+    "scid": []  # schema
 }
 
-global test_server_dict
-test_server_dict = {
+global parent_node_dict
+parent_node_dict = {
     "server": [],
     "database": [],
     "tablespace": [],
-    "role": []
+    "role": [],
+    "schema": []
 }
diff --git a/web/regression/runtests.py b/web/regression/runtests.py
index 87b6004..bdbd6e2 100644
--- a/web/regression/runtests.py
+++ b/web/regression/runtests.py
@@ -10,14 +10,18 @@
 """ This file collect all modules/files present in tests directory and add
 them to TestSuite. """
 from __future__ import print_function
-
 import argparse
 import os
 import sys
 import signal
 import atexit
-import unittest
 import logging
+import traceback
+
+if sys.version_info < (2, 7):
+    import unittest2 as unittest
+else:
+    import unittest
 
 logger = logging.getLogger(__name__)
 file_name = os.path.basename(__file__)
@@ -35,7 +39,7 @@ if sys.path[0] != root:
 
 from pgadmin import create_app
 import config
-import test_setup
+from regression import test_setup
 
 # Delete SQLite db file if exists
 if os.path.isfile(config.TEST_SQLITE_PATH):
@@ -66,7 +70,7 @@ exec (open("setup.py").read())
 from pgadmin.model import SCHEMA_VERSION
 
 # Delay the import test_utils as it needs updated config.SQLITE_PATH
-import test_utils
+from regression import test_utils
 
 config.SETTINGS_SCHEMA_VERSION = SCHEMA_VERSION
 
@@ -189,11 +193,8 @@ def get_tests_result(test_suite):
                     if class_name not in failed_cases_result:
                         skipped_cases_result.append(class_name)
         return total_ran, failed_cases_result, skipped_cases_result
-    except Exception as exception:
-        exception = "Exception: %s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception)
-        logger.exception(exception)
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
 
 
 class StreamToLogger(object):
@@ -248,12 +249,15 @@ if __name__ == '__main__':
     test_utils.login_tester_account(test_client)
 
     servers_info = test_utils.get_config_data()
+    node_name = "all"
+    if args['pkg'] is not None:
+        node_name = args['pkg'].split('.')[-1]
     try:
         for server in servers_info:
             print("\n=============Running the test cases for '%s'============="
                   % server['name'], file=sys.stderr)
             # Create test server
-            test_utils.create_test_server(server)
+            test_utils.create_parent_server_node(server, node_name)
 
             suite = get_suite(test_module_list, server, test_client)
             tests = unittest.TextTestRunner(stream=sys.stderr,
@@ -265,14 +269,16 @@ if __name__ == '__main__':
             test_result[server['name']] = [ran_tests, failed_cases,
                                            skipped_cases]
             # Delete test server
-            test_utils.delete_test_server(test_client)
+            # test_utils.delete_test_server(test_client)
     except SystemExit:
         drop_objects()
 
-    print("\n======================================================================", file=sys.stderr)
+    print("\n==============================================================="
+          "=======", file=sys.stderr)
     print("Test Result Summary", file=sys.stderr)
-    print("======================================================================\n", file=sys.stderr)
-
+    print(
+        "==================================================================="
+        "===\n", file=sys.stderr)
     for server_res in test_result:
         failed_cases = "\n\t\t".join(test_result[server_res][1])
         skipped_cases = "\n\t\t".join(test_result[server_res][2])
@@ -292,6 +298,8 @@ if __name__ == '__main__':
              (total_skipped != 0 and ":\n\t\t" or ""), skipped_cases),
             file=sys.stderr)
 
-    print("======================================================================\n", file=sys.stderr)
+    print(
+        "==================================================================="
+        "===\n", file=sys.stderr)
 
     print("Please check output in file: %s/regression.log\n" % CURRENT_PATH)
diff --git a/web/regression/test_utils.py b/web/regression/test_utils.py
index 731f1b6..36f51b1 100644
--- a/web/regression/test_utils.py
+++ b/web/regression/test_utils.py
@@ -7,7 +7,7 @@
 #
 # ##################################################################
 from __future__ import print_function
-
+import traceback
 import os
 import sys
 import uuid
@@ -20,7 +20,7 @@ import test_setup
 import regression
 
 SERVER_GROUP = test_setup.config_data['server_group']
-file_name = os.path.basename(__file__)
+file_name = os.path.realpath(__file__)
 
 
 def get_db_connection(db, username, password, host, port):
@@ -40,7 +40,7 @@ def login_tester_account(tester):
     :type tester: flask test client object
     :return: None
     """
-    if os.environ['PGADMIN_SETUP_EMAIL'] and\
+    if os.environ['PGADMIN_SETUP_EMAIL'] and \
             os.environ['PGADMIN_SETUP_PASSWORD']:
         email = os.environ['PGADMIN_SETUP_EMAIL']
         password = os.environ['PGADMIN_SETUP_PASSWORD']
@@ -83,11 +83,9 @@ def get_config_data():
     return server_data
 
 
-def write_node_info(node_id, key, node_info=None):
+def write_node_info(key, node_info=None):
     """
     This function append the node details to
-    :param node_id: node id
-    :type node_id: int
     :param key: dict key name to store node info
     :type key: str
     :param node_info: node details
@@ -96,13 +94,8 @@ def write_node_info(node_id, key, node_info=None):
     :rtype: dict
     """
     node_info_dict = regression.node_info_dict
-    if node_info_dict:
-        if key in node_info_dict and node_info_dict[key]:
-            node_info_dict[key].append({node_id: node_info})
-        else:
-            node_info_dict[key] = [{node_id: node_info}]
-    else:
-        raise Exception("node_info_dict is null.")
+    if node_info not in node_info_dict[key]:
+        node_info_dict[key].append(node_info)
 
 
 def clear_node_info_dict():
@@ -123,48 +116,52 @@ def create_database(server, db_name):
         old_isolation_level = connection.isolation_level
         connection.set_isolation_level(0)
         pg_cursor = connection.cursor()
-        pg_cursor.execute("CREATE DATABASE %s" % db_name)
+        pg_cursor.execute('''CREATE DATABASE "%s"''' % db_name)
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
 
         # Get 'oid' from newly created database
-        pg_cursor.execute(
-            "SELECT db.oid from pg_database db WHERE db.datname='%s'" %
-            db_name)
+        pg_cursor.execute("SELECT db.oid from pg_database db WHERE"
+                          " db.datname='%s'" % db_name)
         oid = pg_cursor.fetchone()
         db_id = ''
         if oid:
             db_id = oid[0]
         connection.close()
         return db_id
-    except Exception as exception:
-        exception = "Error while creating database: %s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
 
 
 def drop_database(connection, database_name):
     """This function used to drop the database"""
-
-    try:
+    if database_name not in ["postgres", "template1", "template0"]:
         pg_cursor = connection.cursor()
-        pg_cursor.execute("SELECT * FROM pg_database db WHERE db.datname='%s'"
-                          % database_name)
+        pg_cursor.execute("SELECT * FROM pg_database db WHERE"
+                          " db.datname='%s'" % database_name)
         if pg_cursor.fetchall():
-            # Release pid if any process using database
-            pg_cursor.execute("select pg_terminate_backend(pid) from"
-                              " pg_stat_activity where datname='%s'" %
-                              database_name)
             old_isolation_level = connection.isolation_level
             connection.set_isolation_level(0)
             pg_cursor.execute('''DROP DATABASE "%s"''' % database_name)
             connection.set_isolation_level(old_isolation_level)
             connection.commit()
             connection.close()
-    except Exception as exception:
-        exception = "%s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
+
+
+def drop_tablespace(connection):
+    """This function used to drop the tablespace"""
+    pg_cursor = connection.cursor()
+    pg_cursor.execute("SELECT * FROM pg_tablespace")
+    table_spaces = pg_cursor.fetchall()
+    if table_spaces:
+        for table_space in table_spaces:
+            if table_space[0] not in ["pg_default", "pg_global"]:
+                old_isolation_level = connection.isolation_level
+                connection.set_isolation_level(0)
+                pg_cursor.execute("DROP TABLESPACE %s" % table_space[0])
+                connection.set_isolation_level(old_isolation_level)
+                connection.commit()
+    connection.close()
 
 
 def create_server(server):
@@ -181,73 +178,94 @@ def create_server(server):
                     ' comment) VALUES (?,?,?,?,?,?,?,?,?,?)', server_details)
         server_id = cur.lastrowid
         conn.commit()
+        # Add server info to parent_node_dict
+        regression.parent_node_dict["server"].append({"server_id": server_id,
+                                                      "server": server})
+
         return server_id
     except Exception as exception:
         raise Exception("Error while creating server. %s" % exception)
 
 
-def delete_server(tester, sid):
+def delete_server_with_api(tester, sid):
     """This function used to delete server from SQLite"""
     try:
         url = '/browser/server/obj/' + str(SERVER_GROUP) + "/"
         # Call API to delete the server
         response = tester.delete(url + str(sid))
-    except Exception as exception:
-        exception = "%s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
 
 
-def delete_server_from_sqlite(sid):
-    """This function used to delete server from SQLite"""
-    try:
-        con = sqlite3.connect(config.SQLITE_PATH)
-        cur = con.cursor()
-        server_objects = cur.execute('SELECT * FROM server WHERE id=%s' % sid)
-        ss = server_objects.fetchall()
-        # for i in ss:
-        #     print(">>>>>>>>>>>", i)
-        servers_count = len(ss)
-        # print(">>>>>>>", sid)
-        if servers_count:
-            cur.execute('DELETE FROM server WHERE id=%s' % sid)
-            con.commit()
-        con.close()
-    except Exception as exception:
-        exception = "%s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
+def add_db_to_parent_node_dict(srv_id, db_id, test_db_name):
+    regression.parent_node_dict["database"].append({"server_id": srv_id,
+                                                    "db_id": db_id,
+                                                    "db_name": test_db_name})
 
 
-def create_test_server(server_info):
+def add_schema_to_parent_node_dict(srv_id, db_id, schema_id, schema_name):
+    regression.parent_node_dict["schema"].append({"server_id": srv_id,
+                                                  "db_id": db_id,
+                                                  "schema_id": schema_id,
+                                                  "schema_name": schema_name})
+
+
+def create_parent_server_node(server_info, node_name):
     """
     This function create the test server which will act as parent server,
     the other node will add under this server
     :param server_info: server details
     :type server_info: dict
+    :param node_name: node name
+    :type node_name: str
     :return: None
     """
-    # Create the server
     srv_id = create_server(server_info)
-
-    # Create test database
-    test_db_name = "test_db_%s" % str(uuid.uuid4())[1:8]
-    db_id = create_database(server_info, test_db_name)
-
-    # Add server info to test_server_dict
-    regression.test_server_dict["server"].append({"server_id": srv_id,
-                                                  "server": server_info})
-    regression.test_server_dict["database"].append({"server_id": srv_id,
-                                                    "db_id": db_id,
-                                                    "db_name": test_db_name})
+    if node_name == "databases":
+        # Create test database
+        test_db_name = "test_db_%s" % str(uuid.uuid4())[1:6]
+        db_id = create_database(server_info, test_db_name)
+        add_db_to_parent_node_dict(srv_id, db_id, test_db_name)
+    elif node_name == "schemas":
+        test_db_name = "test_db_%s" % str(uuid.uuid4())[1:6]
+        db_id = create_database(server_info, test_db_name)
+        add_db_to_parent_node_dict(srv_id, db_id, test_db_name)
+        # Create schema
+        schema_name = "test_schema_%s" % str(uuid.uuid4())[1:6]
+        connection = get_db_connection(test_db_name,
+                                       server_info['username'],
+                                       server_info['db_password'],
+                                       server_info['host'],
+                                       server_info['port'])
+
+        schema = regression.schema_utils.create_schema(connection, schema_name)
+        add_schema_to_parent_node_dict(srv_id, db_id, schema[0],
+                                       schema[1])
+    elif node_name not in ["servers", "roles", "tablespaces", "browser"]:
+        # Create test database
+        test_db_name = "test_db_%s" % str(uuid.uuid4())[1:6]
+        db_id = create_database(server_info, test_db_name)
+        add_db_to_parent_node_dict(srv_id, db_id, test_db_name)
+        # Create schema
+        schema_name = "test_schema_%s" % str(uuid.uuid4())[1:6]
+        connection = get_db_connection(test_db_name,
+                                       server_info['username'],
+                                       server_info['db_password'],
+                                       server_info['host'],
+                                       server_info['port'])
+
+        schema = regression.schema_utils.create_schema(connection, schema_name)
+        add_schema_to_parent_node_dict(srv_id, db_id, schema[0],
+                                       schema[1])
 
 
 def delete_test_server(tester):
-    test_server_dict = regression.test_server_dict
-    test_servers = test_server_dict["server"]
-    test_databases = test_server_dict["database"]
-    test_table_spaces = test_server_dict["tablespace"]
     try:
+        parent_node_dict = regression.parent_node_dict
+        test_servers = parent_node_dict["server"]
+        test_databases = parent_node_dict["database"]
+        test_roles = regression.node_info_dict["lrid"]
+        test_table_spaces = regression.node_info_dict["tsid"]
         for test_server in test_servers:
             srv_id = test_server["server_id"]
             servers_dict = test_server["server"]
@@ -260,16 +278,64 @@ def delete_test_server(tester):
                 database_name = database["db_name"]
                 # Drop database
                 drop_database(connection, database_name)
+            for role in test_roles:
+                connection = get_db_connection(servers_dict['db'],
+                                               servers_dict['username'],
+                                               servers_dict['db_password'],
+                                               servers_dict['host'],
+                                               servers_dict['port'])
+                # Delete role
+                regression.roles_utils.delete_role(connection,
+                                                   role["role_name"])
+            for tablespace in test_table_spaces:
+                connection = get_db_connection(servers_dict['db'],
+                                               servers_dict['username'],
+                                               servers_dict['db_password'],
+                                               servers_dict['host'],
+                                               servers_dict['port'])
+                # Delete tablespace
+                regression.tablespace_utils.delete_tablespace(
+                    connection, tablespace["tablespace_name"])
             # Delete server
-            delete_server(tester, srv_id)
-    except Exception as exception:
-        exception = "Exception: %s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
-
-    # Clear test_server_dict
-    for item in regression.test_server_dict:
-        del regression.test_server_dict[item][:]
+            delete_server_with_api(tester, srv_id)
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
+        raise
+
+
+def get_db_password(config_servers, name, host, db_port):
+    db_password = ''
+    for srv in config_servers:
+        if (srv['name'], srv['host'], srv['db_port']) == (name, host, db_port):
+            db_password = srv['db_password']
+    return db_password
+
+
+def get_db_server(sid):
+    connection = ''
+    conn = sqlite3.connect(config.SQLITE_PATH)
+    cur = conn.cursor()
+    server = cur.execute('SELECT name, host, port, maintenance_db,'
+                         ' username FROM server where id=%s' % sid)
+    server = server.fetchone()
+    if server:
+        name = server[0]
+        host = server[1]
+        db_port = server[2]
+        db_name = server[3]
+        username = server[4]
+        config_servers = test_setup.config_data['server_credentials']
+        # Get the db password from config file for appropriate server
+        db_password = get_db_password(config_servers, name, host, db_port)
+        if db_password:
+            # Drop database
+            connection = get_db_connection(db_name,
+                                           username,
+                                           db_password,
+                                           host,
+                                           db_port)
+    conn.close()
+    return connection
 
 
 def remove_db_file():
@@ -282,107 +348,36 @@ def _drop_objects(tester):
     """This function use to cleanup the created the objects(servers, databases,
      schemas etc) during the test suite run"""
     try:
-        conn = sqlite3.connect(config.SQLITE_PATH)
-        cur = conn.cursor()
-        servers = cur.execute('SELECT name, host, port, maintenance_db,'
-                              ' username, id  FROM server')
-        if servers:
-            all_servers = servers.fetchall()
-            for server_info in all_servers:
-                name = server_info[0]
-                host = server_info[1]
-                db_port = server_info[2]
-
-                config_servers = test_setup.config_data['server_credentials']
-                db_password = ''
-                # Get the db password from config file for appropriate server
-                for srv in config_servers:
-                    if (srv['name'], srv['host'], srv['db_port']) == \
-                            (name, host, db_port):
-                        db_password = srv['db_password']
-                if db_password:
-                    # Drop database
-                    connection = get_db_connection(server_info[3],
-                                                   server_info[4],
-                                                   db_password,
-                                                   server_info[1],
-                                                   server_info[2])
-
-                    pg_cursor = connection.cursor()
-                    pg_cursor.execute("SELECT db.datname FROM pg_database db")
-                    databases = pg_cursor.fetchall()
-                    if databases:
-                        for db in databases:
-                            connection = get_db_connection(server_info[3],
-                                                           server_info[4],
-                                                           db_password,
-                                                           server_info[1],
-                                                           server_info[2])
-                            # Do not drop the default databases
-                            if db[0] not in ["postgres", "template1",
-                                             "template0"]:
-                                drop_database(connection, db[0])
-
-                    # Delete tablespace
-                    connection = get_db_connection(server_info[3],
-                                                   server_info[4],
-                                                   db_password,
-                                                   server_info[1],
-                                                   server_info[2])
-                    pg_cursor = connection.cursor()
-                    pg_cursor.execute("SELECT * FROM pg_tablespace")
-                    table_spaces = pg_cursor.fetchall()
-                    if table_spaces:
-                        for tablespace in table_spaces:
-                            # Do not delete default table spaces
-                            if tablespace[0] not in ["pg_default",
-                                                     "pg_global"]:
-                                tablespace_name = tablespace[0]
-                                # Delete tablespace
-                                connection = get_db_connection(server_info[3],
-                                                               server_info[4],
-                                                               db_password,
-                                                               server_info[1],
-                                                               server_info[2])
-                                regression.tablespace_utils.delete_tablespace(
-                                    connection, tablespace_name)
-
-                    # Delete role
-                    connection = get_db_connection(server_info[3],
-                                                   server_info[4],
-                                                   db_password,
-                                                   server_info[1],
-                                                   server_info[2])
-                    pg_cursor = connection.cursor()
-                    pg_cursor.execute("SELECT * FROM pg_catalog.pg_roles")
-                    roles = pg_cursor.fetchall()
-                    if roles:
-                        for role_name in roles:
-                            # Do not delete default table spaces
-                            if role_name[0] not in ["postgres",
-                                                    "enterprisedb"]:
-                                role_name = role_name[0]
-                                # Delete role
-                                regression.roles_utils.delete_role(connection,
-                                                                   role_name)
-
-            for server_info in all_servers:
-                server_id = server_info[5]
-                # Delete server
-                try:
-                    delete_server(tester, server_id)
-                except Exception as exception:
-                    exception = "Exception while deleting server: %s:" \
-                                " line:%s %s" %\
-                                (file_name, sys.exc_traceback.tb_lineno,
-                                 exception)
-                    print(exception, file=sys.stderr)
-                    continue
-        conn.close()
-    except Exception as exception:
-        exception = "Exception: %s: line:%s %s" % (
-            file_name, sys.exc_traceback.tb_lineno, exception)
-        print(exception, file=sys.stderr)
+        test_servers = regression.parent_node_dict["server"] + \
+                       regression.node_info_dict["sid"]
+        test_databases = regression.parent_node_dict["database"] + \
+                         regression.node_info_dict["did"]
+        test_table_spaces = regression.parent_node_dict["tablespace"] + \
+                            regression.node_info_dict["tsid"]
+        test_roles = regression.parent_node_dict["role"] + \
+                     regression.node_info_dict["lrid"]
+        # Drop databases
+        for database in test_databases:
+            connection = get_db_server(database["server_id"])
+            if connection:
+                drop_database(connection, database["db_name"])
+        # Delete table spaces
+        for tablespace in test_table_spaces:
+            connection = get_db_server(tablespace["server_id"])
+            if connection:
+                regression.tablespace_utils.delete_tablespace(
+                    connection, tablespace["tablespace_name"])
+        # Delete roles
+        for role in test_roles:
+            connection = get_db_server(role["server_id"])
+            if connection:
+                regression.roles_utils.delete_role(connection,
+                                                   role["role_name"])
+        # Delete servers
+        for server in test_servers:
+            delete_server_with_api(tester, server["server_id"])
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
     finally:
         # Logout the test client
         logout_tester_account(tester)
